package hoge;

import java.io.FileWriter;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import jp.kaburobo.information.IndexInformation;
import jp.kaburobo.information.InformationManager;
import jp.kaburobo.investment.InvestmentAgent;
import jp.kaburobo.investment.Stock;
import jp.kaburobo.robot.Robot;
import jp.kaburobo.util.Time;


public class CSVTestRobot implements Robot{

	static PrintWriter out;
	static {
		try{
			out = new PrintWriter(
				new FileWriter("out/out.csv")
				//System.out
				);
			//wb_
			out.println(
					"t,"
					+ "R[h,"
					+ "O,"
					+ "nl,"
					+ "Il,"
					+ "l,"
					+ "l,"
					+ "o"
			);
		}catch(Exception e){
			e.printStackTrace();
		}
	}	
	
	
	private void dumpData(Stock stock){
		InformationManager infoManager = agent.getInformationManager();		

		Calendar date = Time.getTime();
		IndexInformation info = infoManager.getIndexInformation(stock);
		

		out.println(
				"" 
				+ toDateString(info.getDate())
				+ "," + stock.getCode()
				+ "," + stock.getName()
				+ "," +info.getOpeningPrice()
				+ "," + info.getClosingPrice()
				+ "," + info.getHighPrice()
				+ "," + info.getLowPrice()
				+ "," + info.getTurnover()
		);
	}
	
	
	
	
	private InvestmentAgent agent;
	
	public void run(InvestmentAgent agent) {

		this.agent = agent;
		
		Stock[] stocks = agent.getStocks();
		for(int i=0; i<stocks.length; i++){
			Stock stock = stocks[i];
			//Stock stock = stocks[0];
			
			dumpData(stock);
		}
		
		
		out.flush();
	}
	
	
	
	private static SimpleDateFormat format = new SimpleDateFormat("yyyy/MM/dd");
	private String toDateString(Calendar calendar){
		return format.format(calendar.getTime());
	}
	
}
